package tutorial.cbr.route;


import org.apache.camel.EndpointInject;
import org.apache.camel.Produce;
import org.apache.camel.ProducerTemplate;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.component.mock.MockEndpoint;
import org.apache.camel.test.blueprint.CamelBlueprintTestSupport;
import org.apache.commons.io.FileUtils;
import org.junit.Test;

import java.io.File;
// import java.util.Scanner;

public class CamelContextXmlTest extends CamelBlueprintTestSupport {

	// TODO Create test message bodies that work for the route(s) being tested
	// Expected message bodies

	
	// To assert that everything works as it should, read the content of created xml files.

	protected  String body1;
	protected  String body2;
	protected  String body3;
	protected  String body4;
	protected  String body5;
	protected  String body6;



	// Templates to send to input endpoints
	@Produce(uri = "file:src/data?noop=true")
	protected ProducerTemplate inputEndpoint;
	// Mock endpoints used to consume messages from the output endpoints and then perform assertions
	@EndpointInject(uri = "mock:output")
	protected MockEndpoint outputEndpoint;
	@EndpointInject(uri = "mock:output2")
	protected MockEndpoint output2Endpoint;
	@EndpointInject(uri = "mock:output3")
	protected MockEndpoint output3Endpoint;
	@EndpointInject(uri = "mock:output4")
	protected MockEndpoint output4Endpoint;
	@EndpointInject(uri = "mock:output5")
	protected MockEndpoint output5Endpoint;

	@Test
	public void testCamelRoute() throws Exception {
		// Easy way of reading content of xml files to a String object. But you must add dependency on commons-io project to pom.xml
		body1 = FileUtils.readFileToString(new File("src/data/message1.xml"));
		body3 = FileUtils.readFileToString(new File("src/data/message3.xml"));
		body5 = FileUtils.readFileToString(new File("src/data/message5.xml"));
		body6 = FileUtils.readFileToString(new File("src/data/message6.xml"));

		// Invalid orders.
		body2 = FileUtils.readFileToString(new File("src/data/message2.xml"));
		body4 = FileUtils.readFileToString(new File("src/data/message4.xml"));


		// Does the same thing as above, but uses standard java
	//	body1 = new Scanner( new File("src/data/message1.xml")).useDelimiter("\\A").next();
	//	body2 = new Scanner( new File("src/data/message2.xml")).useDelimiter("\\A").next();
	//	body3 = new Scanner( new File("src/data/message3.xml")).useDelimiter("\\A").next();
	//	body4 = new Scanner( new File("src/data/message4.xml")).useDelimiter("\\A").next();
	//	body5 = new Scanner( new File("src/data/message5.xml")).useDelimiter("\\A").next();
	//	body6 = new Scanner( new File("src/data/message6.xml")).useDelimiter("\\A").next();



		// Create routes from the output endpoints to our mock endpoints so we can assert expectations
		context.addRoutes(new RouteBuilder() {
			@Override
			public void configure() throws Exception {
				from("file:target/messages/Germany").to(output4Endpoint);
				from("file:target/messages/GreatBritain").to(output3Endpoint);
				from("file:target/messages/USA").to(output2Endpoint);
				from("file:target/messages/France").to(output5Endpoint);
				from("file:target/messages/invalidOrders").to(outputEndpoint);
			}
		});

		// Define some expectations

		// TODO Ensure expectations make sense for the route(s) we're testing

		// Invalid orders
		outputEndpoint.expectedBodiesReceived(body2, body4);

		// For each country one order
		output2Endpoint.expectedBodiesReceived(body1);
		output3Endpoint.expectedBodiesReceived(body3);
		output4Endpoint.expectedBodiesReceived(body6);
		output5Endpoint.expectedBodiesReceived(body5);

		// Validate our expectations
		assertMockEndpointsSatisfied();
	}

	@Override
	protected String getBlueprintDescriptor() {
		return "OSGI-INF/blueprint/camelContext.xml";
	}

}
